#include "../binary_c.h"
No_empty_translation_unit_warning;

#if defined NUCSYN

#include "../maths/lsoda.h"

/*
 * Network code : pp
 * Automatically generated by make_reaction_network_code.pl
 */

/*
 * Reaction SIGMAV_PP H1(H1,beta)H2
 * Alpha=H1, beta=, gamma=beta, delta=H2
 * m=2, n=, p=1, q=1
 */
/*
 * Reaction SIGMAV_DP H2(H1,gamma0)He3
 * Alpha=H2, beta=H1, gamma=gamma0, delta=He3
 * m=1, n=1, p=1, q=1
 */
/*
 * Reaction SIGMAV_He3_He3 He3(He3,2H1)He4
 * Alpha=He3, beta=, gamma=H1, delta=He4
 * m=2, n=, p=2, q=1
 */
/*
 * Reaction SIGMAV_He3_He4 He3(He4,gamma0)Be7
 * Alpha=He3, beta=He4, gamma=gamma0, delta=Be7
 * m=1, n=1, p=1, q=1
 */
/*
 * Reaction SIGMAV_Be7_e Be7(e,gamma0)Li7
 * Alpha=Be7, beta=e, gamma=gamma0, delta=Li7
 * m=1, n=1, p=1, q=1
 */
/*
 * Reaction SIGMAV_Be7_p Be7(H1,He4)He4
 * Alpha=Be7, beta=H1, gamma=He4, delta=He4
 * m=1, n=1, p=1, q=1
 */
/*
 * Reaction SIGMAV_Li7_p_alpha Li7(H1,He4)He4
 * Alpha=Li7, beta=H1, gamma=He4, delta=He4
 * m=1, n=1, p=1, q=1
 */


/*
 * Species / Reactions list:
 *
 * 1 : e : -Be7*e*SIGMAV_Be7_e
 * 2 : H1 : -0.5*H1*H1*SIGMAV_PP -H2*H1*SIGMAV_DP +He3*He3*SIGMAV_He3_He3 -Be7*H1*SIGMAV_Be7_p -Li7*H1*SIGMAV_Li7_p_alpha
 * 3 : H2 : +0.5*H1*H1*SIGMAV_PP -H2*H1*SIGMAV_DP
 * 4 : He3 : +H2*H1*SIGMAV_DP -0.5*He3*He3*SIGMAV_He3_He3 -He3*He4*SIGMAV_He3_He4
 * 5 : He4 : +0.5*He3*He3*SIGMAV_He3_He3 -He3*He4*SIGMAV_He3_He4 +2*Be7*H1*SIGMAV_Be7_p +2*Li7*H1*SIGMAV_Li7_p_alpha
 * 6 : Li7 : +Be7*e*SIGMAV_Be7_e -Li7*H1*SIGMAV_Li7_p_alpha
 * 7 : Be7 : +He3*He4*SIGMAV_He3_He4 -Be7*e*SIGMAV_Be7_e -Be7*H1*SIGMAV_Be7_p
 *
 */
static void ppderivatives_lsoda(double t ,
                                double *  y,
                                double * dydt,
                                void * data);
static void ppjacobian_lsoda(double t Maybe_unused,
                             double * y Maybe_unused,
                             double ** J,
                             void * data);

double nucsyn_burn_lsoda_pp(struct stardata_t * const Restrict stardata,
                            double * const Nin,
                            const double * const sigmav,
                            const double h)
{
#define NSPECIES 7
    double err=0.0;
    double ypp[NSPECIES];
    ypp[0]=Nin[Xe];
    ypp[1]=Nin[XH1];
    ypp[2]=Nin[XH2];
    ypp[3]=Nin[XHe3];
    ypp[4]=Nin[XHe4];
    ypp[5]=Nin[XLi7];
    ypp[6]=Nin[XBe7];

    /* data passed in to the derivatives function */
    struct lsoda_data_t data;
    data.sigmav = (double*)sigmav;
    data.N = (double*)Nin;

    struct lsoda_t * l = stardata->tmpstore->lsoda;

    if(unlikely(l == NULL))
    {
        /* make lsoda space and set it up */
        stardata->tmpstore->lsoda = Malloc(sizeof(struct lsoda_t));
        l = stardata->tmpstore->lsoda;
        lsoda_setup(l);
    }

    if(1)
    {
        /* use Jacobian */
        l->Jacobian = ppjacobian_lsoda;
    }
    else
    {
        l->Jacobian = NULL;
    }

    l->max_steps = INT_MAX; // max number of lsoda steps
    double t = 0.0;

    const int istate =
        n_lsoda(l,
                ypp,
                NSPECIES,
                &t,
                h,
                1e-6,
                &ppderivatives_lsoda,
                &data);

    if(istate != 0)
    {
        Exit_binary_c(BINARY_C_NUCSYN_SOLVER_FAILED,
                      "LSODA error (pp) : istate %d\n",
                      istate);
    }

    Nin[Xe]=ypp[0];
    Nin[XH1]=ypp[1];
    Nin[XH2]=ypp[2];
    Nin[XHe3]=ypp[3];
    Nin[XHe4]=ypp[4];
    Nin[XLi7]=ypp[5];
    Nin[XBe7]=ypp[6];

    return err;
}

static void ppderivatives_lsoda(double t Maybe_unused,
                                double * y,
                                double * dydt,
                                void * data)
{
    /*
     * When called, should subtract 1 from
     * y and dydt because ppderivatives accesses the
     * arrays with [1] as the first element.
     */
    struct lsoda_data_t * const Restrict lsoda_data =
        (struct lsoda_data_t * const Restrict)data;
    ppderivatives(y-1,
                  dydt-1,
                  (const double * const Restrict) lsoda_data->sigmav,
                  NULL);
}

static void ppjacobian_lsoda(double t Maybe_unused,
                             double * y Maybe_unused,
                             double ** J,
                             void * data)
{
    struct lsoda_data_t * const Restrict lsoda_data =
        (struct lsoda_data_t * const Restrict)data;
    const double * const Restrict N =
        (const double * const Restrict) lsoda_data->N;
    const double * const Restrict sigmav =
        (const double * const Restrict) lsoda_data->sigmav;
    ppjacobian(J,
               N,
               sigmav);
}

#endif // NUCSYN && NUCSYN_NETWORK_PP
